SystemOrganization addCategory: #'SCouchDB-JQuery'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Test'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Test-Functional'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Lib'!

WAFileLibrary subclass: #JQCouchDBJQueryLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Lib'!

!JQCouchDBJQueryLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/3/2013 00:30'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript
		url: 'http://127.0.0.1:5984/_utils/script/jquery.js'! !

WAFileLibrary subclass: #JQCouchDBLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Lib'!

!JQCouchDBLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/31/2013 00:54'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript
		url: 'http://127.0.0.1:5984/_utils/script/jquery.couch.js'! !

WAComponent subclass: #JQAlbumEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional'!

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 00:05'!
json
	^ JSJson new! !

WAComponent subclass: #JQAlbums
	instanceVariableNames: 'loggedIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional'!

!JQAlbums class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 12:23'!
canBeRoot
^true! !

!JQAlbums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 00:06'!
initialize
super initialize.
loggedIn:=false! !

!JQAlbums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 00:08'!
renderAlbumsPageOn:html! !

!JQAlbums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 00:08'!
renderContentOn:html
loggedIn
	ifTrue:[self renderAlbumsPageOn:html]
	ifFalse:[self renderLoginDialogOn:html]! !

!JQAlbums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 09:09'!
renderCouchInitOn:html
	html div with:[
		html span:'Status:'.
		html code id:#logger; with:'waiting for connection'.
		].
	html script:(
		html jQuery ready:(
			html jQuery couch login:'admin' password:'95t5boru' ;
				onSuccess:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString]);
				onError:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString]))
		)! !

!JQAlbums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 09:07'!
renderLoginFormOn:html
! !

WAComponent subclass: #JQSCouchDBTest
	instanceVariableNames: 'textInput aCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional'!

!JQSCouchDBTest class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:12'!
canBeRoot
^true! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/1/2013 13:11'!
json
	^ JSJson new! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/3/2013 23:53'!
renderContentOn:html
"self requestContext response headers at:'Access-Control-Allow-Origin' put:'"
html heading:'ToDo-List Demo CouchDB'.
self renderCouchInitOn:html.
self renderDocOn:html! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/31/2013 09:34'!
renderCouchInitOn:html
	html div with:[
		html span:'Status:'.
		html code id:#logger; with:'waiting for connection'.
		].
	html script:(
		html jQuery ready:(
			html jQuery couch login:'admin' password:'95t5boru' ;
				onSuccess:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString]);
				onError:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString]))
		)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 09:07'!
renderCouchLoadViewOn:js 

	^ js jQuery couch db:'test';allDocs;
		onSuccess: 
					((js jQuery:#ulist) load 
							html:[:html|
								aCollection
								ifNil:[.html listItem:'empty list']
								 ifNotNil:[
									self halt.
									(aCollection at:'rows' ) do:[:i|
										html listItem: (i at:#id). 
									].
								]
							];
					callback:[:data|
						self halt.
						aCollection:= JSJsonParser parse: data.
						]	 
					value: (self json stringify: js jQuery event))! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 09:07'!
renderCouchSaveDocOn:js content:aWord

	js << js jQuery couch db:'test';saveDoc: ('{"word":"', aWord,'"}');
				onSuccess: (self renderCouchLoadViewOn: js).
	
	
		! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/1/2013 11:23'!
renderDocOn:html
 self
      renderLabel: 'Text-Input'
      control: [ :id :script |
         html textInput
            id: id;
            value: textInput;
            callback: [ :value | textInput := value ];
            onChange: (script html: [ :h | h render: textInput ]).
         "the following code checks if a manual submit does a correct encoding:"
         html submitButton
            onClick: (html jQuery ajax
               callback: [ :value | textInput := value ] 
		   value: (html jQuery id: id) value;
               script: [ :s | 
				self renderCouchSaveDocOn: s content: textInput.
				]);
            with: 'Manual Submit'.
  	 ]
      model: textInput
      on: html.

	html div id:#dataList; with:[
		html unorderedList id:#ulist. 
		].

! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:06'!
renderLabel: aString control: aBlock model: anObject on: html
   | id |
   html fieldSet: [
      html label
         for: (id := html nextId);
         with: aString.
      html span: [
         aBlock
            value: id
            " update the paragraph "
            value: ((html jQuery this	
               parents: 'fieldset';
               find: 'p') load
                  " serialize all nearby form elements "
                  serialize: (html jQuery this		
                     parents: 'span';
                     find: ':input')) ].
      html paragraph: anObject ]
! !

JSObjectTest subclass: #JQueryCouchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test'!

JQueryCouchTest subclass: #JQueryCouchDbTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test'!

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/30/2012 23:16'!
couch
	^ self jQuery couch! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 00:13'!
couchDb
	^ self jQuery couchDb! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/5/2012 05:58'!
test0Couch
	self
		assert: (self jQuery couch)
		equals: self function , '.couch;'.
self
		assert: (self jQuery couch urlPrefix:'http://localhost:5984')
		equals: self function , '.couch.urlPrefix="http://localhost:5984";'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/5/2012 05:57'!
test0Database

	self
		assert: (self jQuery couch db:'test';create)
		equals: self function , '.couch.db("test").create;'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 14:58'!
test1Info

	self
		assert: (self jQuery couch info;onSuccess:'alert(data);')
		equals: self function , '.couch.info({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/5/2012 05:54'!
test2allDbs

	self
		assert: (self jQuery couch allDbs)
		equals: self function , '.couch.allDbs;'.
	self
		assert: (self jQuery couch allDbs;onSuccess:'alert(data);')
		equals: self function , '.couch.allDbs({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:23'!
test3SignUp
|user|

	
	self
		assert: (self jQuery couch signUp:'bob' password:'superpassword')
		equals: self function , '.couch.signup({"_id":"org.couchdb.user:bob","name":"bob"},"superpassword");'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:41'!
test4Login


	
	self
		assert: (self jQuery couch login:'bob' password:'superpassword';onSuccess:'done')
		equals: self function , '.couch.login({"success":function(data){done},"password":"superpassword","name":"bob"});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:44'!
test5session

	self
		assert: (self jQuery couch session;onSuccess:'alert(data);')
		equals: self function , '.couch.session({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:46'!
test6logout

	self
		assert: (self jQuery couch logout;onSuccess:'alert(data);')
		equals: self function , '.couch.logout({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:48'!
test7activeTasks

	self
		assert: (self jQuery couch activeTasks;onSuccess:'alert(data);')
		equals: self function , '.couch.activeTasks({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:58'!
test8config

	self
		assert: (self jQuery couch config:'uuids'option:'algorithm';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm");'.
	self
		assert: (self jQuery couch config:'uuids'option:'algorithm'value:'sequential';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm","sequential");'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 17:02'!
test9userDb

	self
		assert: (self jQuery couch userDb:'alert(data);')
		equals: self function , '.couch.userDb(function(data){alert(data);});'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 17:06'!
testAnewUUID

	self
		assert: (self jQuery couch newUUID)
		equals: self function , '.couch.newUUID();'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2012 09:20'!
testBReplicateDatabase

	self
		assert: (self jQuery couch replicate:'DB' to:'NEWDB' createTarget:true;onSuccess:'done';onError:'error')
		equals: self function , '.couch.replicate("DB","NEWDB",{"success":function(data){done},"error":function(status){error}},{"create_target":true});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2012 09:20'!
testCDatabaseCreate

	self
		assert: (self jQuery couch db:'test';create;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").create({"success":function(data){done},"error":function(status){error}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2012 09:21'!
testDDatabaseInfo

	self
		assert: (self jQuery couch db:'test';info;onSuccess:'done')
		equals: self function , '.couch.db("test").info({"success":function(data){done}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 17:38'!
testEsaveDoc

	self
		assert: (self jQuery couch db:'test';saveDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").saveDoc("aDoc",{"success":function(data){done},"error":function(status){error}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:00'!
testFopenDoc

	self
		assert: (self jQuery couch db:'test';openDoc:'d12ee5ea1df6baa2b06451f44a019ab9';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").openDoc("d12ee5ea1df6baa2b06451f44a019ab9",{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:15'!
testGremoveDoc

	self
		assert: (self jQuery couch db:'test';removeDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").removeDoc("aDoc",{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:50'!
testHbulkSave

	self
		assert: (self jQuery couch db:'test';bulkSave:(JSStream on:'aDoc');onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkSave({"docs":aDoc},{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:55'!
testIbulkRemove

	self
		assert: (self jQuery couch db:'test';bulkRemove:(JSStream on:'aDoc');onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkRemove({"docs":aDoc},{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 19:08'!
testJallDocs

	self
		assert: (self jQuery couch db:'test';allDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDocs({"success":function(data){done}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 17:18'!
testKallDesignDocs

	self
		assert: (self jQuery couch db:'test';allDesignDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDesignDocs({"success":function(data){done}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 21:39'!
testKquery

	self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}});'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}});'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 19:20'!
testLallApps

	self
		assert: (self jQuery couch db:'test';allApps;forEachApp:('console.log(appName+" "+appPath+" "+ddoc');onSuccess:'done')
		equals: self function , '.couch.db("test").allApps({"success":function(data){done},"eachApp":function(appName,appPath,ddoc){console.log(appName+" "+appPath+" "+ddoc}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 17:19'!
testMquery

self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}});'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}});'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 17:51'!
testOview

	self
		assert: (self jQuery couch db:'test';view:('default/all');onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").view("default/all",{"reduce":false,"success":function(data){done},"error":function(status){err}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:02'!
testPlist

	self
		assert: (self jQuery couch db:'test';list:('default/all') with:'all';onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").list("default/all","all",{"reduce":false,"success":function(data){done},"error":function(status){err}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:06'!
testQcompact

	self
		assert: (self jQuery couch db:'test';compact;onSuccess:'done')
		equals: self function , '.couch.db("test").compact({"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:08'!
testRviewCleanup

	self
		assert: (self jQuery couch db:'test';viewCleanup;onSuccess:'done')
		equals: self function , '.couch.db("test").viewCleanup({"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:13'!
testScompactView

	self
		assert: (self jQuery couch db:'test';compactView:'default';onSuccess:'done')
		equals: self function , '.couch.db("test").compactView("default",{"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:40'!
testTchange

	self
		assert: (self jQuery couch db:'test';onChange:'done')
		equals: self function , '.couch.db("test").changes().onChange(function(data){done});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 19:22'!
testUdrop

	self
		assert: (self jQuery couch db:'test';drop;onSuccess:'done')
		equals: self function , '.couch.db("test").drop({"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 19:36'!
testVcopyDoc

	self
		assert: (self jQuery couch db:'test';copyDoc:'11111';onSuccess:'done';onError:'err';beforeSend:'send')
		equals: self function , '.couch.db("test").copyDoc("11111",{"success":function(data){done},"error":function(status){err}},{"beforeSend":function(xhr){send}});'.
		
	! !

!JQueryCouchTest class methodsFor: 'testing' stamp: 'JesusMari 3/30/2012 23:13'!
isAbstract
	^ self name = #JQueryTest! !

!JQueryCouchTest class methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
packageNamesUnderTest
	^ #('JQuery-Core')! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
function
	"Answers the name of the jQuery function. This can be either '$' or 'jQuery' or any other user chosen name. This makes sure the tests run in any case."

	^ JQuery functionName! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery
	^ JQueryClass context: self renderContext! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery: anObject
	^ self jQuery with: anObject! !

JQPlugin subclass: #JQCouch
	instanceVariableNames: 'couchFunction command database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery'!

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:47'!
activeTasks
self command:'activeTasks'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:23'!
allApps
self command:'allApps'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 14:30'!
allDbs
	self command:'allDbs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:14'!
allDesignDocs
self command:'allDesignDocs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 19:02'!
allDocs
self command:'allDocs'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 4/3/2012 19:33'!
arguments
	| arguments jSonOptions|
	arguments := OrderedCollection new.
	jSonOptions:=Dictionary new.
	self options
		at: 'success'
		ifPresent: [ :value | jSonOptions at:'success' put: value ].
	self options
		at: 'eachApp'
		ifPresent: [ :value | jSonOptions at:'eachApp' put: value ].
	self options
		at: 'loginpassword'
		ifPresent: [ :value | jSonOptions at:'password' put: value ].
	self options
		at: 'name'
		ifPresent: [ :value | jSonOptions at:'name' put: value ].
	self options
		at: 'error'
		ifPresent: [ :value | jSonOptions at:'error' put: value ].
	self options
		at: 'reduce'
		ifPresent: [ :value | jSonOptions at:'reduce' put: value ].
	self options
		at: 'view'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'list'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'change'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'successUserDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'userDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'password'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'replicateDb'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateNewDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'doc'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'bulkDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'mapFunction'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'reduceFunction'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'language'
		ifPresent: [ :value | arguments add: value ].	
							
	(jSonOptions size>0) ifTrue:[arguments add:jSonOptions].
	"this options after succcess...stupid order..."
	
	self options
		at: 'section'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option-value'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateTarget'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'beforeSend'
		ifPresent: [ :value | arguments add: value ].				
	^ arguments! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:37'!
beforeSend:aDocument 
"aDocument is a JSon doc with the beforeSend property that contains a jscript function"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'beforeSend' put:( aDocument asFunction:#(xhr)).
	options at:'beforeSend' put:aDoc	
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 7/25/2012 18:28'!
bulkRemove:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'docs' put: (aDocument).
	
	self command:'bulkRemove'.
	self optionAt: 'bulkDoc' put: (JSStream on:aDocument).
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 7/25/2012 18:28'!
bulkSave:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'docs' put: aDocument.
	
	self command:'bulkSave'.
	self optionAt: 'bulkDoc' put: (JSStream on:aDocument).
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command
	^ command! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command: anObject
	command := anObject! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:03'!
compact
self command:'compact'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:13'!
compactView:aView
"aView name example: 'default/all'"
	
	self command:'compactView'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:57'!
config:aSection option:anOption
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:58'!
config:aSection option:anOption value:aValue
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption.
self options at:'option-value' put:aValue! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 7/25/2012 18:28'!
copyDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'copyDoc'.
	self optionAt: 'doc' put: (JSStream on:aDocument).
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 22:38'!
couchFunction
	^ couchFunction! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 01:16'!
couchFunction: aFunction
(aFunction isKindOf: BlockClosure)
ifTrue:[	couchFunction:= ((aFunction value)greaseString)]
ifFalse:[	couchFunction := aFunction ]! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:24'!
create
command:='create'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:22'!
database
	^ Array with:database! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:23'!
database: anString
	database := anString.
	self couchFunction: [(JSStream on:'db') call:'' withArguments:(self database)].! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:25'!
db:aDatabase

self database:aDatabase! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 19:21'!
drop
command:='drop'! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:20'!
forEachApp: anObject
	self optionAt: 'eachApp' put: (anObject asFunction:#(appName appPath ddoc)).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 13:44'!
info
self command:'info'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 7/24/2012 16:51'!
javascriptContentOn: aStream

	aStream
		javascript: self owner;
		nextPut: $.;
		nextPutAll: self method.
	
	couchFunction notNil ifTrue:[ 
		aStream  nextPut:$.;nextPutAll:couchFunction].
	command notNil ifTrue:[ 
		aStream nextPut:$. ;nextPutAll:command].
	self options size>0 ifTrue:[
		JSStream encodeArguments: self arguments on: aStream
		].
	"aStream nextPut:$;"
	
		
	! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:00'!
list:aView with:aList
"list a view with aList function'"
	
	self command:'list'.
	self optionAt: 'view' put: aView.
	self optionAt: 'list' put: aList.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:33'!
login:aUserName password:anString
"anUserName and password must be anString"

	self command:'login'.
	self optionAt: 'name' put: aUserName.
	self optionAt:'loginpassword' put: anString! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:45'!
logout
self command:'logout'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 23:19'!
method
	^ 'couch'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/5/2012 05:54'!
newUUID
self command:'newUUID()'.! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 18:36'!
onChange: anObject
	self command:'changes().onChange'.
	self optionAt: 'change' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 3/31/2012 17:23'!
onError: anObject
	self optionAt: 'error' put: (anObject asFunction:#(status)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 2/1/2013 13:15'!
onSuccess: anObject
	self optionAt: 'success' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 7/25/2012 18:28'!
openDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'openDoc'.
	self optionAt: 'doc' put:(JSStream on:aDocument).
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:33'!
query:mapFunction 
self query:mapFunction reduceFunction:'_count' language:'javascript'reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction 
self query:mapFunction reduceFunction:reduceFunction language:'javascript' reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction language:language 
self query:mapFunction reduceFunction:reduceFunction language:language reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:24'!
query:mapFunction reduceFunction:reduceFunction language:language reduce:aBoolean
self command:'query'.
self optionAt: 'mapFunction' put: mapFunction.
self optionAt: 'reduceFunction' put: reduceFunction. 
self optionAt: 'language' put: language.
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:50'!
reduce:aBoolean
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 7/25/2012 18:29'!
removeDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'removeDoc'.
	self optionAt: 'doc' put: (JSStream on:aDocument).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/1/2012 09:09'!
replicate:aDatabase to:aNewDatabase createTarget:aBoolean
"create_target must be a Dictionary wuth the following entrances:
{create_target:true}"
|createTarget|
	createTarget:=Dictionary new.
	createTarget at:'create_target' put: aBoolean.

	self command:'replicate'.
	self optionAt: 'replicateDb' put: aDatabase.
	self optionAt: 'replicateNewDb' put: aNewDatabase.
	self optionAt: 'replicateTarget' put: createTarget.! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 7/25/2012 18:27'!
saveDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	self command:'saveDoc'.
	self optionAt: 'doc' put: (JSStream on:aDocument).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:44'!
session
self command:'session'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:21'!
signUp:aUserName password:anString
"anUserDoc must be a Dictionary wuth the following entrances:
{_id:'org.couchdb.user:bob' , name:'bob'}"
|aUserDoc|
	aUserDoc:=Dictionary new.
	aUserDoc at:'_id' put: ('org.couchdb.user:',aUserName).
	aUserDoc at:'name' put:aUserName.
	self command:'signup'.
	self optionAt: 'userDoc' put: aUserDoc.
	self optionAt: 'password' put: anString.! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 4/5/2012 05:58'!
urlPrefix: anObject
		self couchFunction: [(JSStream on:'urlPrefix="',anObject,'"')].
	! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 17:00'!
userDb:aFunction
self command:'userDb'.
self optionAt: 'successUserDb' put: (aFunction asFunction:#(data)).! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:34'!
view:aView
"aView name example: 'default/all'"
	
	self command:'view'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/3/2012 18:08'!
viewCleanup
self command:'viewCleanup'! !

!JQueryClass methodsFor: '*SCouchdb-JQuery' stamp: 'JesusMari 3/30/2012 23:17'!
couch
	^ self create: JQCouch! !
